"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogAxiosErrorInterceptor = exports.AxiosConverter = void 0;
const common_1 = require("@nestjs/common");
const operators_1 = require("rxjs/operators");
const uuid_1 = require("uuid");
class AxiosConverter {
    static getCurl(request = {}, anonymizedFields = []) {
        if (!(request === null || request === void 0 ? void 0 : request.config))
            return 'Axios response is required';
        request = request.config;
        let header = '';
        Object.keys((request === null || request === void 0 ? void 0 : request.headers) || {}).forEach((r) => (header += `--header '${r}: ${request.headers[String(r)]}' `));
        let params = '';
        Object.keys((request === null || request === void 0 ? void 0 : request.params) || {}).forEach((p) => (params += `/${p}/${request.params[String(p)]}`));
        const hasQueryParams = new RegExp('\\?.*').exec(request.url) || [];
        let query = '';
        if (hasQueryParams.length) {
            query = hasQueryParams[0];
            request.url = request.url.substring(0, request.url.lastIndexOf('?'));
        }
        const body = getBody(anonymizedFields, `--data-raw '${request === null || request === void 0 ? void 0 : request.data}'`);
        const paramsUrl = `${(request === null || request === void 0 ? void 0 : request.params) ? params : ''}`;
        const curl = `curl --location -g --request ${request.method.toUpperCase()} '${request.url + paramsUrl + query}' ${header} ${(request === null || request === void 0 ? void 0 : request.data) ? body : ''}`;
        return curl.trim().replace(/\\"/g, "\"");
    }
}
exports.AxiosConverter = AxiosConverter;
let LogAxiosErrorInterceptor = class LogAxiosErrorInterceptor {
    intercept(ctx, next) {
        return next.handle().pipe((0, operators_1.catchError)((error) => {
            if (!(error === null || error === void 0 ? void 0 : error.config))
                throw error;
            if (!(error === null || error === void 0 ? void 0 : error.uuid)) {
                error.uuid = (0, uuid_1.v4)();
            }
            new common_1.Logger(error.uuid).warn(AxiosConverter.getCurl(error));
            throw error;
        }));
    }
};
exports.LogAxiosErrorInterceptor = LogAxiosErrorInterceptor;
exports.LogAxiosErrorInterceptor = LogAxiosErrorInterceptor = __decorate([
    (0, common_1.Injectable)()
], LogAxiosErrorInterceptor);
const getBody = (anonymizedFields, body) => {
    if (!anonymizedFields.length) {
        return body;
    }
    for (const field of anonymizedFields) {
        const regexField = `("${field}":)"(.*?)"`;
        const regex = new RegExp(`${regexField}`);
        const exec = regex.exec(body);
        if ((exec === null || exec === void 0 ? void 0 : exec.length) === 3) {
            body = body.replace(exec[2], "******");
        }
    }
    return body;
};
//# sourceMappingURL=converter.js.map